#! /bin/bash
#
# install script für schukodaemon am Server
#
##################################################################

miniskpfad="/home/samba/progs/minisk/"
etcpfad="/etc/linuxmuster/maus/"
sbinpfad="/usr/sbin/"
initpfad="/etc/init.d/"

##################################################################

if [ "$(id -u)" != "0" ]; then
   echo "###################################"
   echo "# This script must be run as root #"
   echo "###################################"
   exit 1
fi

echo "### Installation schukodaemon startet ###"

mkdir -p $etcpfad

if [ -e "$etcpfad"schukodaemon.cfg ]; then
   echo "############################################################################"
   echo "# ACHTUNG!                                                                 #"
   echo "# Die Konfigurationsdatei schukodaemon.cfg ex. schon, sie wird beibehalten.#"
   echo "# Eine neue Konfigurationsdatei liegt nun unter schukodaemon.cfg.neu.      #"
   echo "# Ggf. die bisherige Konfigurationsdatei entsprechend anpassen.            #"
   echo "############################################################################"
   cp schukodaemon.cfg "$etcpfad"schukodaemon.cfg.neu
   chmod 640 "$etcpfad"schukodaemon.cfg.neu
else
   cp schukodaemon.cfg $etcpfad
   chmod 640 "$etcpfad"schukodaemon.cfg
fi

echo "Prozesse schukodaemon stop ..."
killall -e -9 schukodaemon
sleep 2

openssl genrsa -out "$etcpfad"sk.key 2048
openssl req -x509 -new -nodes -subj "/C=DE/ST=BW/L=Schule/O=schukodaemon/CN=schukodaemon" -extensions v3_ca -key "$etcpfad"sk.key -days 3650 -out "$etcpfad"sk.cert -sha512

echo "Firewall wird konfiguriert ..."

sed -i '/[^0-9]9731/ !s/^tcp .*/&,9731/' /etc/linuxmuster/allowed_ports
restart-fw --int

cp schukodaemon $sbinpfad
cp schukodaemon.sh $initpfad

chown root:root "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh
chmod 755 "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh

echo "Boot-Script wird aktiviert ..."

/usr/sbin/update-rc.d schukodaemon.sh defaults

"$initpfad"schukodaemon.sh start

echo "### Installation schukodaemon beendet ###"

exit 0
